CfnDBInstance L1 construct
The AWS::DocDB::DBInstance Amazon DocumentDB (with MongoDB compatibility) resource describes a DBInstance.
For more information, see DBInstance in the Amazon DocumentDB Developer Guide .
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_docdb as docdb } from 'aws-cdk-lib';
const cfnDBInstance = new docdb.CfnDBInstance(this, 'MyCfnDBInstance', {
dbClusterIdentifier: 'dbClusterIdentifier',
dbInstanceClass: 'dbInstanceClass',
// the properties below are optional
autoMinorVersionUpgrade: false,
availabilityZone: 'availabilityZone',
caCertificateIdentifier: 'caCertificateIdentifier',
certificateRotationRestart: false,
dbInstanceIdentifier: 'dbInstanceIdentifier',
enablePerformanceInsights: false,
preferredMaintenanceWindow: 'preferredMaintenanceWindow',
tags: [{
key: 'key',
value: 'value',
}],
});
from aws_cdk import CfnTag
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_docdb as docdb
cfn_db_instance = docdb.CfnDBInstance(self, "MyCfnDBInstance",
db_cluster_identifier="dbClusterIdentifier",
db_instance_class="dbInstanceClass",
# the properties below are optional
auto_minor_version_upgrade=False,
availability_zone="availabilityZone",
ca_certificate_identifier="caCertificateIdentifier",
certificate_rotation_restart=False,
db_instance_identifier="dbInstanceIdentifier",
enable_performance_insights=False,
preferred_maintenance_window="preferredMaintenanceWindow",
tags=[CfnTag(
key="key",
value="value"
)]
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.docdb.*;
CfnDBInstance cfnDBInstance = CfnDBInstance.Builder.create(this, "MyCfnDBInstance")
.dbClusterIdentifier("dbClusterIdentifier")
.dbInstanceClass("dbInstanceClass")
// the properties below are optional
.autoMinorVersionUpgrade(false)
.availabilityZone("availabilityZone")
.caCertificateIdentifier("caCertificateIdentifier")
.certificateRotationRestart(false)
.dbInstanceIdentifier("dbInstanceIdentifier")
.enablePerformanceInsights(false)
.preferredMaintenanceWindow("preferredMaintenanceWindow")
.tags(List.of(CfnTag.builder()
.key("key")
.value("value")
.build()))
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.DocDB;
var cfnDBInstance = new CfnDBInstance(this, "MyCfnDBInstance", new CfnDBInstanceProps {
DbClusterIdentifier = "dbClusterIdentifier",
DbInstanceClass = "dbInstanceClass",
// the properties below are optional
AutoMinorVersionUpgrade = false,
AvailabilityZone = "availabilityZone",
CaCertificateIdentifier = "caCertificateIdentifier",
CertificateRotationRestart = false,
DbInstanceIdentifier = "dbInstanceIdentifier",
EnablePerformanceInsights = false,
PreferredMaintenanceWindow = "preferredMaintenanceWindow",
Tags = new [] { new CfnTag {
Key = "key",
Value = "value"
} }
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnDBInstance := awscdk.Aws_docdb.NewCfnDBInstance(this, jsii.String("MyCfnDBInstance"), &CfnDBInstanceProps{
DbClusterIdentifier: jsii.String("dbClusterIdentifier"),
DbInstanceClass: jsii.String("dbInstanceClass"),
// the properties below are optional
AutoMinorVersionUpgrade: jsii.Boolean(false),
AvailabilityZone: jsii.String("availabilityZone"),
CaCertificateIdentifier: jsii.String("caCertificateIdentifier"),
CertificateRotationRestart: jsii.Boolean(false),
DbInstanceIdentifier: jsii.String("dbInstanceIdentifier"),
EnablePerformanceInsights: jsii.Boolean(false),
PreferredMaintenanceWindow: jsii.String("preferredMaintenanceWindow"),
Tags: []CfnTag{
&CfnTag{
Key: jsii.String("key"),
Value: jsii.String("value"),
},
},
})
Initializer
new CfnDBInstance(scope: Construct, id: string, props: CfnDBInstanceProps)
CfnDBInstance(scope: Construct, id: str, props: CfnDBInstanceProps)
new CfnDBInstance(Construct scope, String id, CfnDBInstanceProps props)
new CfnDBInstance(Construct scope, string id, CfnDBInstanceProps props)
NewCfnDBInstance(Scope Construct, Id *string, Props CfnDBInstanceProps)
Construct Props
autoMinorVersionUpgradeboolean | IResolvableauto_minor_version_upgradetyping.Union[bool, IResolvable]autoMinorVersionUpgradeBooleanAutoMinorVersionUpgradeboolAutoMinorVersionUpgradeinterface{}#Amazon DocumentDB does not perform minor version upgrades regardless of the value set.
Default: false
availabilityZonestringavailability_zonestravailabilityZoneStringAvailabilityZonestringAvailabilityZone*string#Default: A random, system-chosen Availability Zone in the endpoint's AWS Region .
Example: us-east-1d
caCertificateIdentifierstringca_certificate_identifierstrcaCertificateIdentifierStringCaCertificateIdentifierstringCaCertificateIdentifier*string#certificateRotationRestartboolean | IResolvablecertificate_rotation_restarttyping.Union[bool, IResolvable]certificateRotationRestartBooleanCertificateRotationRestartboolCertificateRotationRestartinterface{}#notes
By default, the DB instance is restarted when you rotate your SSL/TLS certificate. The certificate is not updated until the DB instance is restarted.
Set this parameter only if you are not using SSL/TLS to connect to the DB instance.
If you are using SSL/TLS to connect to the DB instance, see Updating Your Amazon DocumentDB TLS Certificates and Encrypting Data in Transit in the Amazon DocumentDB Developer Guide .
dbClusterIdentifierstringdb_cluster_identifierstrdbClusterIdentifierStringDbClusterIdentifierstringDbClusterIdentifier*stringrequired#dbInstanceClassstringdb_instance_classstrdbInstanceClassStringDbInstanceClassstringDbInstanceClass*stringrequired#for example, db.m4.large . If you change the class of an instance there can be some interruption in the cluster's service.
dbInstanceIdentifierstringdb_instance_identifierstrdbInstanceIdentifierStringDbInstanceIdentifierstringDbInstanceIdentifier*string#Constraints:
- Must contain from 1 to 63 letters, numbers, or hyphens.
- The first character must be a letter.
- Cannot end with a hyphen or contain two consecutive hyphens.
Example: mydbinstance
enablePerformanceInsightsboolean | IResolvableenable_performance_insightstyping.Union[bool, IResolvable]enablePerformanceInsightsBooleanEnablePerformanceInsightsboolEnablePerformanceInsightsinterface{}#For more information, see Using Amazon Performance Insights .
preferredMaintenanceWindowstringpreferred_maintenance_windowstrpreferredMaintenanceWindowStringPreferredMaintenanceWindowstringPreferredMaintenanceWindow*string#notes
Format: ddd:hh24:mi-ddd:hh24:mi
The default is a 30-minute window selected at random from an 8-hour block of time for each AWS Region , occurring on a random day of the week.
Valid days: Mon, Tue, Wed, Thu, Fri, Sat, Sun
Constraints: Minimum 30-minute window.
Properties
For example: sample-cluster.cluster-abcdefghijkl.us-east-1.docdb.amazonaws.com .
autoMinorVersionUpgradeboolean | IResolvableauto_minor_version_upgradetyping.Union[bool, IResolvable]autoMinorVersionUpgradeBooleanAutoMinorVersionUpgradeboolAutoMinorVersionUpgradeinterface{}#availabilityZonestringavailability_zonestravailabilityZoneStringAvailabilityZonestringAvailabilityZone*string#caCertificateIdentifierstringca_certificate_identifierstrcaCertificateIdentifierStringCaCertificateIdentifierstringCaCertificateIdentifier*string#certificateRotationRestartboolean | IResolvablecertificate_rotation_restarttyping.Union[bool, IResolvable]certificateRotationRestartBooleanCertificateRotationRestartboolCertificateRotationRestartinterface{}#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsrequired#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#dbClusterIdentifierstringdb_cluster_identifierstrdbClusterIdentifierStringDbClusterIdentifierstringDbClusterIdentifier*stringrequired#dbInstanceClassstringdb_instance_classstrdbInstanceClassStringDbInstanceClassstringDbInstanceClass*stringrequired#dbInstanceIdentifierstringdb_instance_identifierstrdbInstanceIdentifierStringDbInstanceIdentifierstringDbInstanceIdentifier*string#This parameter is stored as a lowercase string.
dbInstanceRefDBInstanceReferencedb_instance_refDBInstanceReferencedbInstanceRefDBInstanceReferenceDbInstanceRefDBInstanceReferenceDbInstanceRefDBInstanceReferencerequired#enablePerformanceInsightsboolean | IResolvableenable_performance_insightstyping.Union[bool, IResolvable]enablePerformanceInsightsBooleanEnablePerformanceInsightsboolEnablePerformanceInsightsinterface{}#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
preferredMaintenanceWindowstringpreferred_maintenance_windowstrpreferredMaintenanceWindowStringPreferredMaintenanceWindowstringPreferredMaintenanceWindow*string#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
CfnElements must be defined within a stack scope (directly or indirectly).
Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
arnForDBInstance(resource: IDBInstanceRef): string@staticmethod def arn_for_db_instance(resource: IDBInstanceRef) -> strpublic static String arnForDBInstance(IDBInstanceRef resource)public static string ArnForDBInstance(IDBInstanceRef resource)func ArnForDBInstance(Resource IDBInstanceRef) *stringstatic#cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#fromDBInstanceId(scope: Construct, id: string, dbInstanceId: string): IDBInstanceRef@staticmethod def from_db_instance_id(scope: Construct, id: str, db_instance_id: str) -> IDBInstanceRefpublic static IDBInstanceRef fromDBInstanceId(Construct scope, String id, String dbInstanceId)public static IDBInstanceRef FromDBInstanceId(Construct scope, string id, string dbInstanceId)func FromDBInstanceId(Scope Construct, Id *string, DbInstanceId *string) IDBInstanceRefstatic#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnDBInstance(x: any): boolean@staticmethod def is_cfn_db_instance(x: Any) -> boolpublic static Boolean isCfnDBInstance(Object x)public static bool IsCfnDBInstance(object x)func IsCfnDBInstance(X interface{}) *boolstatic#isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.